Linus Torvalds | a3e870f | 2005-05-30 12:51:00 -0700 | [diff] [blame] | 1 | #!/bin/sh |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 2 | # |
| 3 | # Copyright (c) 2005 Linus Torvalds |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 4 | # Copyright (c) 2006 Junio C Hamano |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 5 | |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 6 | USAGE='[-a | --interactive] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [[-i | -o] <path>...]' |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 7 | SUBDIRECTORY_OK=Yes |
Junio C Hamano | ae2b0f1 | 2005-11-24 00:12:11 -0800 | [diff] [blame] | 8 | . git-sh-setup |
Shawn O. Pearce | 7eff28a | 2006-12-30 23:32:38 -0500 | [diff] [blame] | 9 | require_work_tree |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 10 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 11 | git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 12 | |
| 13 | case "$0" in |
| 14 | *status) |
| 15 | status_only=t |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 16 | ;; |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 17 | *commit) |
| 18 | status_only= |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 19 | ;; |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 20 | esac |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 21 | |
| 22 | refuse_partial () { |
| 23 | echo >&2 "$1" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 24 | echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?" |
| 25 | exit 1 |
| 26 | } |
| 27 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 28 | THIS_INDEX="$GIT_DIR/index" |
| 29 | NEXT_INDEX="$GIT_DIR/next-index$$" |
| 30 | rm -f "$NEXT_INDEX" |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 31 | save_index () { |
Junio C Hamano | cc7d5bc | 2006-06-29 14:48:22 -0700 | [diff] [blame] | 32 | cp -p "$THIS_INDEX" "$NEXT_INDEX" |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 33 | } |
| 34 | |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 35 | run_status () { |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 36 | # If TMP_INDEX is defined, that means we are doing |
| 37 | # "--only" partial commit, and that index file is used |
| 38 | # to build the tree for the commit. Otherwise, if |
| 39 | # NEXT_INDEX exists, that is the index file used to |
| 40 | # make the commit. Otherwise we are using as-is commit |
| 41 | # so the regular index file is what we use to compare. |
| 42 | if test '' != "$TMP_INDEX" |
| 43 | then |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 44 | GIT_INDEX_FILE="$TMP_INDEX" |
| 45 | export GIT_INDEX_FILE |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 46 | elif test -f "$NEXT_INDEX" |
| 47 | then |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 48 | GIT_INDEX_FILE="$NEXT_INDEX" |
| 49 | export GIT_INDEX_FILE |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 50 | fi |
| 51 | |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 52 | case "$status_only" in |
| 53 | t) color= ;; |
| 54 | *) color=--nocolor ;; |
| 55 | esac |
| 56 | git-runstatus ${color} \ |
| 57 | ${verbose:+--verbose} \ |
| 58 | ${amend:+--amend} \ |
Johannes Schindelin | 2074cb0 | 2006-09-12 22:45:12 +0200 | [diff] [blame] | 59 | ${untracked_files:+--untracked} |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 60 | } |
| 61 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 62 | trap ' |
| 63 | test -z "$TMP_INDEX" || { |
| 64 | test -f "$TMP_INDEX" && rm -f "$TMP_INDEX" |
| 65 | } |
| 66 | rm -f "$NEXT_INDEX" |
| 67 | ' 0 |
| 68 | |
| 69 | ################################################################ |
| 70 | # Command line argument parsing and sanity checking |
| 71 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 72 | all= |
| 73 | also= |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 74 | interactive= |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 75 | only= |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 76 | logfile= |
| 77 | use_commit= |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 78 | amend= |
Jeff King | cda8ab5 | 2006-06-23 09:43:38 -0400 | [diff] [blame] | 79 | edit_flag= |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 80 | no_edit= |
| 81 | log_given= |
| 82 | log_message= |
| 83 | verify=t |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 84 | quiet= |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 85 | verbose= |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 86 | signoff= |
| 87 | force_author= |
Junio C Hamano | bba319b | 2006-02-14 12:40:20 -0800 | [diff] [blame] | 88 | only_include_assumed= |
Matthias Lederhofer | 443f833 | 2006-05-22 23:02:06 +0200 | [diff] [blame] | 89 | untracked_files= |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 90 | while case "$#" in 0) break;; esac |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 91 | do |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 92 | case "$1" in |
| 93 | -F|--F|-f|--f|--fi|--fil|--file) |
| 94 | case "$#" in 1) usage ;; esac |
| 95 | shift |
| 96 | no_edit=t |
| 97 | log_given=t$log_given |
| 98 | logfile="$1" |
| 99 | shift |
| 100 | ;; |
| 101 | -F*|-f*) |
| 102 | no_edit=t |
| 103 | log_given=t$log_given |
| 104 | logfile=`expr "z$1" : 'z-[Ff]\(.*\)'` |
| 105 | shift |
| 106 | ;; |
| 107 | --F=*|--f=*|--fi=*|--fil=*|--file=*) |
| 108 | no_edit=t |
| 109 | log_given=t$log_given |
| 110 | logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'` |
| 111 | shift |
| 112 | ;; |
| 113 | -a|--a|--al|--all) |
| 114 | all=t |
| 115 | shift |
| 116 | ;; |
| 117 | --au=*|--aut=*|--auth=*|--autho=*|--author=*) |
| 118 | force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'` |
| 119 | shift |
| 120 | ;; |
| 121 | --au|--aut|--auth|--autho|--author) |
| 122 | case "$#" in 1) usage ;; esac |
| 123 | shift |
| 124 | force_author="$1" |
| 125 | shift |
| 126 | ;; |
| 127 | -e|--e|--ed|--edi|--edit) |
| 128 | edit_flag=t |
| 129 | shift |
| 130 | ;; |
| 131 | -i|--i|--in|--inc|--incl|--inclu|--includ|--include) |
| 132 | also=t |
| 133 | shift |
| 134 | ;; |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 135 | --int|--inte|--inter|--intera|--interac|--interact|--interacti|\ |
| 136 | --interactiv|--interactive) |
| 137 | interactive=t |
| 138 | shift |
| 139 | ;; |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 140 | -o|--o|--on|--onl|--only) |
| 141 | only=t |
| 142 | shift |
| 143 | ;; |
| 144 | -m|--m|--me|--mes|--mess|--messa|--messag|--message) |
| 145 | case "$#" in 1) usage ;; esac |
| 146 | shift |
| 147 | log_given=m$log_given |
| 148 | if test "$log_message" = '' |
| 149 | then |
| 150 | log_message="$1" |
| 151 | else |
| 152 | log_message="$log_message |
Shawn Pearce | 6891281 | 2006-05-29 04:45:49 -0400 | [diff] [blame] | 153 | |
| 154 | $1" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 155 | fi |
| 156 | no_edit=t |
| 157 | shift |
| 158 | ;; |
| 159 | -m*) |
| 160 | log_given=m$log_given |
| 161 | if test "$log_message" = '' |
| 162 | then |
| 163 | log_message=`expr "z$1" : 'z-m\(.*\)'` |
| 164 | else |
| 165 | log_message="$log_message |
Shawn Pearce | 6891281 | 2006-05-29 04:45:49 -0400 | [diff] [blame] | 166 | |
Dennis Stosberg | 8096fae | 2006-06-27 18:54:26 +0200 | [diff] [blame] | 167 | `expr "z$1" : 'z-m\(.*\)'`" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 168 | fi |
| 169 | no_edit=t |
| 170 | shift |
| 171 | ;; |
| 172 | --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*) |
| 173 | log_given=m$log_given |
| 174 | if test "$log_message" = '' |
| 175 | then |
| 176 | log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'` |
| 177 | else |
| 178 | log_message="$log_message |
Shawn Pearce | 6891281 | 2006-05-29 04:45:49 -0400 | [diff] [blame] | 179 | |
Dennis Stosberg | 8096fae | 2006-06-27 18:54:26 +0200 | [diff] [blame] | 180 | `expr "z$1" : 'zq-[^=]*=\(.*\)'`" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 181 | fi |
| 182 | no_edit=t |
| 183 | shift |
| 184 | ;; |
| 185 | -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\ |
| 186 | --no-verify) |
| 187 | verify= |
| 188 | shift |
| 189 | ;; |
| 190 | --a|--am|--ame|--amen|--amend) |
| 191 | amend=t |
| 192 | log_given=t$log_given |
| 193 | use_commit=HEAD |
| 194 | shift |
| 195 | ;; |
| 196 | -c) |
| 197 | case "$#" in 1) usage ;; esac |
| 198 | shift |
| 199 | log_given=t$log_given |
| 200 | use_commit="$1" |
| 201 | no_edit= |
| 202 | shift |
| 203 | ;; |
| 204 | --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\ |
| 205 | --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\ |
| 206 | --reedit-messag=*|--reedit-message=*) |
| 207 | log_given=t$log_given |
| 208 | use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'` |
| 209 | no_edit= |
| 210 | shift |
| 211 | ;; |
| 212 | --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\ |
| 213 | --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\ |
| 214 | --reedit-message) |
| 215 | case "$#" in 1) usage ;; esac |
| 216 | shift |
| 217 | log_given=t$log_given |
| 218 | use_commit="$1" |
| 219 | no_edit= |
| 220 | shift |
| 221 | ;; |
| 222 | -C) |
| 223 | case "$#" in 1) usage ;; esac |
| 224 | shift |
| 225 | log_given=t$log_given |
| 226 | use_commit="$1" |
| 227 | no_edit=t |
| 228 | shift |
| 229 | ;; |
| 230 | --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\ |
| 231 | --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\ |
| 232 | --reuse-message=*) |
| 233 | log_given=t$log_given |
| 234 | use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'` |
| 235 | no_edit=t |
| 236 | shift |
| 237 | ;; |
| 238 | --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\ |
| 239 | --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message) |
| 240 | case "$#" in 1) usage ;; esac |
| 241 | shift |
| 242 | log_given=t$log_given |
| 243 | use_commit="$1" |
| 244 | no_edit=t |
| 245 | shift |
| 246 | ;; |
| 247 | -s|--s|--si|--sig|--sign|--signo|--signof|--signoff) |
| 248 | signoff=t |
| 249 | shift |
| 250 | ;; |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 251 | -q|--q|--qu|--qui|--quie|--quiet) |
| 252 | quiet=t |
| 253 | shift |
| 254 | ;; |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 255 | -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose) |
| 256 | verbose=t |
| 257 | shift |
| 258 | ;; |
| 259 | -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\ |
| 260 | --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\ |
| 261 | --untracked-file|--untracked-files) |
| 262 | untracked_files=t |
| 263 | shift |
| 264 | ;; |
| 265 | --) |
| 266 | shift |
| 267 | break |
| 268 | ;; |
| 269 | -*) |
| 270 | usage |
| 271 | ;; |
| 272 | *) |
| 273 | break |
| 274 | ;; |
| 275 | esac |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 276 | done |
Jeff King | cda8ab5 | 2006-06-23 09:43:38 -0400 | [diff] [blame] | 277 | case "$edit_flag" in t) no_edit= ;; esac |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 278 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 279 | ################################################################ |
| 280 | # Sanity check options |
| 281 | |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 282 | case "$amend,$initial_commit" in |
| 283 | t,t) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 284 | die "You do not have anything to amend." ;; |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 285 | t,) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 286 | if [ -f "$GIT_DIR/MERGE_HEAD" ]; then |
| 287 | die "You are in the middle of a merge -- cannot amend." |
| 288 | fi ;; |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 289 | esac |
| 290 | |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 291 | case "$log_given" in |
| 292 | tt*) |
Peter Eriksen | 497171e | 2007-01-24 20:54:46 +0100 | [diff] [blame] | 293 | die "Only one of -c/-C/-F/--amend can be used." ;; |
Shawn Pearce | 6891281 | 2006-05-29 04:45:49 -0400 | [diff] [blame] | 294 | *tm*|*mt*) |
Peter Eriksen | 497171e | 2007-01-24 20:54:46 +0100 | [diff] [blame] | 295 | die "Option -m cannot be combined with -c/-C/-F/--amend." ;; |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 296 | esac |
| 297 | |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 298 | case "$#,$also,$only,$amend" in |
| 299 | *,t,t,*) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 300 | die "Only one of --include/--only can be used." ;; |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 301 | 0,t,,* | 0,,t,) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 302 | die "No paths with --include/--only does not make sense." ;; |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 303 | 0,,t,t) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 304 | only_include_assumed="# Clever... amending the last one with dirty index." ;; |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 305 | 0,,,*) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 306 | ;; |
Junio C Hamano | 6a74642 | 2006-04-20 01:20:56 -0700 | [diff] [blame] | 307 | *,,,*) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 308 | only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..." |
| 309 | also= |
| 310 | ;; |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 311 | esac |
| 312 | unset only |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 313 | case "$all,$interactive,$also,$#" in |
| 314 | *t,*t,*) |
| 315 | die "Cannot use -a, --interactive or -i at the same time." ;; |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 316 | t,,[1-9]*) |
| 317 | die "Paths with -a does not make sense." ;; |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 318 | ,t,[1-9]*) |
| 319 | die "Paths with --interactive does not make sense." ;; |
| 320 | ,,t,0) |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 321 | die "No paths with -i does not make sense." ;; |
| 322 | esac |
| 323 | |
| 324 | ################################################################ |
| 325 | # Prepare index to have a tree to be committed |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 326 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 327 | case "$all,$also" in |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 328 | t,) |
Fredrik Kuivinen | 755b99d | 2007-02-22 21:28:12 +0100 | [diff] [blame] | 329 | if test ! -f "$THIS_INDEX" |
| 330 | then |
| 331 | die 'nothing to commit (use "git add file1 file2" to include for commit)' |
| 332 | fi |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 333 | save_index && |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 334 | ( |
Junio C Hamano | 514c09f | 2007-01-12 12:49:05 -0800 | [diff] [blame] | 335 | cd_to_toplevel && |
| 336 | GIT_INDEX_FILE="$NEXT_INDEX" && |
| 337 | export GIT_INDEX_FILE && |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 338 | git-diff-files --name-only -z | |
| 339 | git-update-index --remove -z --stdin |
Junio C Hamano | 514c09f | 2007-01-12 12:49:05 -0800 | [diff] [blame] | 340 | ) || exit |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 341 | ;; |
| 342 | ,t) |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 343 | save_index && |
Junio C Hamano | bba319b | 2006-02-14 12:40:20 -0800 | [diff] [blame] | 344 | git-ls-files --error-unmatch -- "$@" >/dev/null || exit |
| 345 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 346 | git-diff-files --name-only -z -- "$@" | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 347 | ( |
Junio C Hamano | 514c09f | 2007-01-12 12:49:05 -0800 | [diff] [blame] | 348 | cd_to_toplevel && |
| 349 | GIT_INDEX_FILE="$NEXT_INDEX" && |
| 350 | export GIT_INDEX_FILE && |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 351 | git-update-index --remove -z --stdin |
Junio C Hamano | 514c09f | 2007-01-12 12:49:05 -0800 | [diff] [blame] | 352 | ) || exit |
Junio C Hamano | 22cff6a | 2005-08-16 18:08:19 -0700 | [diff] [blame] | 353 | ;; |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 354 | ,) |
Paolo Bonzini | 6cbf07e | 2007-03-05 08:57:53 +0100 | [diff] [blame] | 355 | if test "$interactive" = t; then |
| 356 | git add --interactive || exit |
| 357 | fi |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 358 | case "$#" in |
| 359 | 0) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 360 | ;; # commit as-is |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 361 | *) |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 362 | if test -f "$GIT_DIR/MERGE_HEAD" |
| 363 | then |
| 364 | refuse_partial "Cannot do a partial commit during a merge." |
| 365 | fi |
| 366 | TMP_INDEX="$GIT_DIR/tmp-index$$" |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 367 | commit_only=`git-ls-files --error-unmatch -- "$@"` || exit |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 368 | |
Junio C Hamano | 158d057 | 2006-12-09 22:32:43 -0800 | [diff] [blame] | 369 | # Build a temporary index and update the real index |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 370 | # the same way. |
| 371 | if test -z "$initial_commit" |
| 372 | then |
Junio C Hamano | 5e7f56a | 2007-03-31 23:27:41 -0700 | [diff] [blame] | 373 | GIT_INDEX_FILE="$THIS_INDEX" \ |
| 374 | git-read-tree --index-output="$TMP_INDEX" -i -m HEAD |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 375 | else |
| 376 | rm -f "$TMP_INDEX" |
| 377 | fi || exit |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 378 | |
Junio C Hamano | 293623e | 2007-05-25 22:00:54 -0700 | [diff] [blame] | 379 | printf '%s\n' "$commit_only" | |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 380 | GIT_INDEX_FILE="$TMP_INDEX" \ |
| 381 | git-update-index --add --remove --stdin && |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 382 | |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 383 | save_index && |
Junio C Hamano | 293623e | 2007-05-25 22:00:54 -0700 | [diff] [blame] | 384 | printf '%s\n' "$commit_only" | |
Martin Waitz | 3de63c3 | 2006-10-07 21:07:40 +0200 | [diff] [blame] | 385 | ( |
| 386 | GIT_INDEX_FILE="$NEXT_INDEX" |
| 387 | export GIT_INDEX_FILE |
| 388 | git-update-index --remove --stdin |
| 389 | ) || exit |
| 390 | ;; |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 391 | esac |
Junio C Hamano | f678dd1 | 2005-11-25 13:33:14 -0800 | [diff] [blame] | 392 | ;; |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 393 | esac |
| 394 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 395 | ################################################################ |
| 396 | # If we do as-is commit, the index file will be THIS_INDEX, |
| 397 | # otherwise NEXT_INDEX after we make this commit. We leave |
| 398 | # the index as is if we abort. |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 399 | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 400 | if test -f "$NEXT_INDEX" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 401 | then |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 402 | USE_INDEX="$NEXT_INDEX" |
| 403 | else |
| 404 | USE_INDEX="$THIS_INDEX" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 405 | fi |
| 406 | |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 407 | case "$status_only" in |
| 408 | t) |
| 409 | # This will silently fail in a read-only repository, which is |
| 410 | # what we want. |
| 411 | GIT_INDEX_FILE="$USE_INDEX" git-update-index -q --unmerged --refresh |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 412 | run_status |
| 413 | exit $? |
Junio C Hamano | 2b5f9a8 | 2007-02-22 00:28:49 -0800 | [diff] [blame] | 414 | ;; |
| 415 | '') |
| 416 | GIT_INDEX_FILE="$USE_INDEX" git-update-index -q --refresh || exit |
| 417 | ;; |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 418 | esac |
| 419 | |
| 420 | ################################################################ |
| 421 | # Grab commit message, write out tree and make commit. |
| 422 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 423 | if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit |
| 424 | then |
| 425 | if test "$TMP_INDEX" |
| 426 | then |
| 427 | GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit |
| 428 | else |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 429 | GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 430 | fi || exit |
| 431 | fi |
Junio C Hamano | 0cfe1d3 | 2005-08-12 23:39:15 -0700 | [diff] [blame] | 432 | |
Junio C Hamano | aba2da1 | 2005-08-25 18:57:35 -0700 | [diff] [blame] | 433 | if test "$log_message" != '' |
| 434 | then |
Junio C Hamano | 293623e | 2007-05-25 22:00:54 -0700 | [diff] [blame] | 435 | printf '%s\n' "$log_message" |
Junio C Hamano | aba2da1 | 2005-08-25 18:57:35 -0700 | [diff] [blame] | 436 | elif test "$logfile" != "" |
| 437 | then |
| 438 | if test "$logfile" = - |
| 439 | then |
| 440 | test -t 0 && |
| 441 | echo >&2 "(reading log message from standard input)" |
| 442 | cat |
| 443 | else |
| 444 | cat <"$logfile" |
| 445 | fi |
| 446 | elif test "$use_commit" != "" |
| 447 | then |
Tom Prince | e0d10e1 | 2007-01-28 16:16:53 -0800 | [diff] [blame] | 448 | encoding=$(git config i18n.commitencoding || echo UTF-8) |
Junio C Hamano | 5ac2715 | 2007-01-13 13:33:07 -0800 | [diff] [blame] | 449 | git show -s --pretty=raw --encoding="$encoding" "$use_commit" | |
| 450 | sed -e '1,/^$/d' -e 's/^ //' |
Luben Tuikov | a9cb3c6 | 2006-10-12 14:52:42 -0700 | [diff] [blame] | 451 | elif test -f "$GIT_DIR/MERGE_MSG" |
Junio C Hamano | e521580 | 2005-11-01 22:01:28 -0800 | [diff] [blame] | 452 | then |
| 453 | cat "$GIT_DIR/MERGE_MSG" |
Junio C Hamano | 7d0c688 | 2006-06-23 01:37:02 -0700 | [diff] [blame] | 454 | elif test -f "$GIT_DIR/SQUASH_MSG" |
| 455 | then |
| 456 | cat "$GIT_DIR/SQUASH_MSG" |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 457 | fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 458 | |
| 459 | case "$signoff" in |
| 460 | t) |
Junio C Hamano | dbaa06a | 2007-01-29 01:06:27 -0800 | [diff] [blame] | 461 | need_blank_before_signoff= |
| 462 | tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG | |
| 463 | grep 'Signed-off-by:' >/dev/null || need_blank_before_signoff=yes |
Junio C Hamano | f641339 | 2005-10-03 23:49:46 -0700 | [diff] [blame] | 464 | { |
Junio C Hamano | dbaa06a | 2007-01-29 01:06:27 -0800 | [diff] [blame] | 465 | test -z "$need_blank_before_signoff" || echo |
Junio C Hamano | f641339 | 2005-10-03 23:49:46 -0700 | [diff] [blame] | 466 | git-var GIT_COMMITTER_IDENT | sed -e ' |
| 467 | s/>.*/>/ |
| 468 | s/^/Signed-off-by: / |
| 469 | ' |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 470 | } >>"$GIT_DIR"/COMMIT_EDITMSG |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 471 | ;; |
| 472 | esac |
| 473 | |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 474 | if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 475 | echo "#" |
Alex Riesen | b6ae540 | 2006-01-05 12:44:59 +0100 | [diff] [blame] | 476 | echo "# It looks like you may be committing a MERGE." |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 477 | echo "# If this is not correct, please remove the file" |
Junio C Hamano | 293623e | 2007-05-25 22:00:54 -0700 | [diff] [blame] | 478 | printf '%s\n' "# $GIT_DIR/MERGE_HEAD" |
Junio C Hamano | 2d56993 | 2005-08-31 17:15:25 -0700 | [diff] [blame] | 479 | echo "# and try again" |
| 480 | echo "#" |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 481 | fi >>"$GIT_DIR"/COMMIT_EDITMSG |
Junio C Hamano | aba2da1 | 2005-08-25 18:57:35 -0700 | [diff] [blame] | 482 | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 483 | # Author |
Junio C Hamano | 83e24dc | 2007-01-22 13:03:31 -0800 | [diff] [blame] | 484 | if test '' != "$use_commit" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 485 | then |
| 486 | pick_author_script=' |
| 487 | /^author /{ |
| 488 | s/'\''/'\''\\'\'\''/g |
| 489 | h |
| 490 | s/^author \([^<]*\) <[^>]*> .*$/\1/ |
| 491 | s/'\''/'\''\'\'\''/g |
| 492 | s/.*/GIT_AUTHOR_NAME='\''&'\''/p |
| 493 | |
| 494 | g |
| 495 | s/^author [^<]* <\([^>]*\)> .*$/\1/ |
| 496 | s/'\''/'\''\'\'\''/g |
| 497 | s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p |
| 498 | |
| 499 | g |
| 500 | s/^author [^<]* <[^>]*> \(.*\)$/\1/ |
| 501 | s/'\''/'\''\'\'\''/g |
| 502 | s/.*/GIT_AUTHOR_DATE='\''&'\''/p |
| 503 | |
| 504 | q |
| 505 | } |
| 506 | ' |
Tom Prince | e0d10e1 | 2007-01-28 16:16:53 -0800 | [diff] [blame] | 507 | encoding=$(git config i18n.commitencoding || echo UTF-8) |
Junio C Hamano | 5ac2715 | 2007-01-13 13:33:07 -0800 | [diff] [blame] | 508 | set_author_env=`git show -s --pretty=raw --encoding="$encoding" "$use_commit" | |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 509 | LANG=C LC_ALL=C sed -ne "$pick_author_script"` |
| 510 | eval "$set_author_env" |
| 511 | export GIT_AUTHOR_NAME |
| 512 | export GIT_AUTHOR_EMAIL |
| 513 | export GIT_AUTHOR_DATE |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 514 | fi |
Junio C Hamano | 83e24dc | 2007-01-22 13:03:31 -0800 | [diff] [blame] | 515 | if test '' != "$force_author" |
| 516 | then |
| 517 | GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` && |
| 518 | GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` && |
| 519 | test '' != "$GIT_AUTHOR_NAME" && |
| 520 | test '' != "$GIT_AUTHOR_EMAIL" || |
| 521 | die "malformed --author parameter" |
| 522 | export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL |
| 523 | fi |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 524 | |
Linus Torvalds | 96069cf | 2005-06-14 10:20:14 -0700 | [diff] [blame] | 525 | PARENTS="-p HEAD" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 526 | if test -z "$initial_commit" |
Junio C Hamano | 8098a17 | 2005-09-30 14:26:57 -0700 | [diff] [blame] | 527 | then |
Shawn Pearce | a3a733e | 2006-07-10 22:48:47 -0400 | [diff] [blame] | 528 | rloga='commit' |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 529 | if [ -f "$GIT_DIR/MERGE_HEAD" ]; then |
Shawn Pearce | a3a733e | 2006-07-10 22:48:47 -0400 | [diff] [blame] | 530 | rloga='commit (merge)' |
Junio C Hamano | 91063bb | 2005-09-08 13:47:12 -0700 | [diff] [blame] | 531 | PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"` |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 532 | elif test -n "$amend"; then |
Shawn Pearce | a3a733e | 2006-07-10 22:48:47 -0400 | [diff] [blame] | 533 | rloga='commit (amend)' |
Junio C Hamano | b4019f0 | 2006-03-02 21:04:05 -0800 | [diff] [blame] | 534 | PARENTS=$(git-cat-file commit HEAD | |
| 535 | sed -n -e '/^$/q' -e 's/^parent /-p /p') |
Junio C Hamano | aba2da1 | 2005-08-25 18:57:35 -0700 | [diff] [blame] | 536 | fi |
Junio C Hamano | cede752 | 2006-09-27 02:06:31 -0700 | [diff] [blame] | 537 | current="$(git-rev-parse --verify HEAD)" |
Junio C Hamano | 8098a17 | 2005-09-30 14:26:57 -0700 | [diff] [blame] | 538 | else |
| 539 | if [ -z "$(git-ls-files)" ]; then |
Shawn O. Pearce | aeb80c7 | 2006-12-15 21:53:09 -0500 | [diff] [blame] | 540 | echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)' |
Junio C Hamano | 8098a17 | 2005-09-30 14:26:57 -0700 | [diff] [blame] | 541 | exit 1 |
| 542 | fi |
| 543 | PARENTS="" |
Shawn Pearce | a3a733e | 2006-07-10 22:48:47 -0400 | [diff] [blame] | 544 | rloga='commit (initial)' |
Junio C Hamano | cede752 | 2006-09-27 02:06:31 -0700 | [diff] [blame] | 545 | current='' |
Linus Torvalds | 96069cf | 2005-06-14 10:20:14 -0700 | [diff] [blame] | 546 | fi |
Junio C Hamano | 23913dc | 2007-01-19 17:12:11 -0800 | [diff] [blame] | 547 | set_reflog_action "$rloga" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 548 | |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 549 | if test -z "$no_edit" |
| 550 | then |
| 551 | { |
Martin Waitz | 88a1531 | 2006-05-26 01:42:18 +0200 | [diff] [blame] | 552 | echo "" |
| 553 | echo "# Please enter the commit message for your changes." |
| 554 | echo "# (Comment lines starting with '#' will not be included)" |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 555 | test -z "$only_include_assumed" || echo "$only_include_assumed" |
| 556 | run_status |
| 557 | } >>"$GIT_DIR"/COMMIT_EDITMSG |
| 558 | else |
| 559 | # we need to check if there is anything to commit |
| 560 | run_status >/dev/null |
| 561 | fi |
Junio C Hamano | 8588452 | 2006-03-04 20:36:28 -0800 | [diff] [blame] | 562 | if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ] |
Linus Torvalds | a3e870f | 2005-05-30 12:51:00 -0700 | [diff] [blame] | 563 | then |
Junio C Hamano | 7d0c688 | 2006-06-23 01:37:02 -0700 | [diff] [blame] | 564 | rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG" |
Junio C Hamano | 5a798fb | 2006-02-05 16:08:01 -0800 | [diff] [blame] | 565 | run_status |
Linus Torvalds | a3e870f | 2005-05-30 12:51:00 -0700 | [diff] [blame] | 566 | exit 1 |
| 567 | fi |
Junio C Hamano | 475443c | 2006-04-12 11:45:18 -0700 | [diff] [blame] | 568 | |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 569 | case "$no_edit" in |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 570 | '') |
Junio C Hamano | 7334f06 | 2006-02-04 22:10:32 -0800 | [diff] [blame] | 571 | case "${VISUAL:-$EDITOR},$TERM" in |
| 572 | ,dumb) |
| 573 | echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined." |
| 574 | echo >&2 "Please supply the commit log message using either" |
| 575 | echo >&2 "-m or -F option. A boilerplate log message has" |
| 576 | echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG" |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 577 | exit 1 |
| 578 | ;; |
Junio C Hamano | 7334f06 | 2006-02-04 22:10:32 -0800 | [diff] [blame] | 579 | esac |
Sean | ec4e69c | 2006-05-13 23:09:32 -0400 | [diff] [blame] | 580 | git-var GIT_AUTHOR_IDENT > /dev/null || die |
| 581 | git-var GIT_COMMITTER_IDENT > /dev/null || die |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 582 | ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG" |
Junio C Hamano | 5fec3ef | 2005-06-25 02:22:05 -0700 | [diff] [blame] | 583 | ;; |
| 584 | esac |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 585 | |
| 586 | case "$verify" in |
| 587 | t) |
| 588 | if test -x "$GIT_DIR"/hooks/commit-msg |
| 589 | then |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 590 | "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 591 | fi |
| 592 | esac |
| 593 | |
Yann Dirson | 29f4ad8 | 2006-06-24 00:04:05 +0200 | [diff] [blame] | 594 | if test -z "$no_edit" |
| 595 | then |
| 596 | sed -e ' |
| 597 | /^diff --git a\/.*/{ |
| 598 | s/// |
| 599 | q |
| 600 | } |
| 601 | /^#/d |
| 602 | ' "$GIT_DIR"/COMMIT_EDITMSG |
| 603 | else |
| 604 | cat "$GIT_DIR"/COMMIT_EDITMSG |
| 605 | fi | |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 606 | git-stripspace >"$GIT_DIR"/COMMIT_MSG |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 607 | |
| 608 | if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG | |
| 609 | git-stripspace | |
| 610 | wc -l` && |
| 611 | test 0 -lt $cnt |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 612 | then |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 613 | if test -z "$TMP_INDEX" |
| 614 | then |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 615 | tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree) |
Junio C Hamano | 130fcca | 2006-02-05 00:07:44 -0800 | [diff] [blame] | 616 | else |
| 617 | tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) && |
| 618 | rm -f "$TMP_INDEX" |
| 619 | fi && |
Santi_Béjar | f8e2c54 | 2005-10-09 17:30:19 -0700 | [diff] [blame] | 620 | commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) && |
Shawn Pearce | 67644a4 | 2006-05-19 05:16:18 -0400 | [diff] [blame] | 621 | rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) && |
Junio C Hamano | 23913dc | 2007-01-19 17:12:11 -0800 | [diff] [blame] | 622 | git-update-ref -m "$GIT_REFLOG_ACTION: $rlogm" HEAD $commit "$current" && |
Luben Tuikov | a9cb3c6 | 2006-10-12 14:52:42 -0700 | [diff] [blame] | 623 | rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" && |
Junio C Hamano | cf7bb58 | 2006-02-10 00:45:59 -0800 | [diff] [blame] | 624 | if test -f "$NEXT_INDEX" |
| 625 | then |
| 626 | mv "$NEXT_INDEX" "$THIS_INDEX" |
| 627 | else |
| 628 | : ;# happy |
| 629 | fi |
Junio C Hamano | 0c09129 | 2005-08-08 17:03:14 -0700 | [diff] [blame] | 630 | else |
| 631 | echo >&2 "* no commit message? aborting commit." |
| 632 | false |
| 633 | fi |
Linus Torvalds | 170241b | 2005-06-19 19:57:01 -0700 | [diff] [blame] | 634 | ret="$?" |
Junio C Hamano | 7d0c688 | 2006-06-23 01:37:02 -0700 | [diff] [blame] | 635 | rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG" |
Junio C Hamano | c93d88a | 2007-03-05 12:35:41 -0800 | [diff] [blame] | 636 | |
| 637 | cd_to_toplevel |
| 638 | |
Junio C Hamano | 1536dd9c6 | 2006-02-11 18:55:43 -0800 | [diff] [blame] | 639 | if test -d "$GIT_DIR/rr-cache" |
| 640 | then |
| 641 | git-rerere |
| 642 | fi |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 643 | |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 644 | if test "$ret" = 0 |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 645 | then |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 646 | if test -x "$GIT_DIR"/hooks/post-commit |
| 647 | then |
| 648 | "$GIT_DIR"/hooks/post-commit |
| 649 | fi |
| 650 | if test -z "$quiet" |
| 651 | then |
Michael S. Tsirkin | c7263d4 | 2007-04-16 08:51:11 +0300 | [diff] [blame] | 652 | commit=`git-diff-tree --always --shortstat --pretty="format:%h: %s"\ |
| 653 | --summary --root HEAD --` |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 654 | echo "Created${initial_commit:+ initial} commit $commit" |
Nicolas Pitre | ebd124c | 2006-12-14 23:15:44 -0500 | [diff] [blame] | 655 | fi |
Junio C Hamano | 89e2c5f | 2005-08-18 17:20:08 -0700 | [diff] [blame] | 656 | fi |
Junio C Hamano | 61f5cb7 | 2006-10-24 21:48:55 -0700 | [diff] [blame] | 657 | |
Linus Torvalds | 170241b | 2005-06-19 19:57:01 -0700 | [diff] [blame] | 658 | exit "$ret" |